import psutil
import whatap.pack.smbase_pack as smbase_pack
import whatap.pack as pack
import time, os
from StringIO import StringIO
import subprocess


oldVmstat = None

def GetCpuMemory():
    jiff = float(100)
    
    cpu_times = psutil.cpu_times(percpu=False)
    global oldVmstat
    if not oldVmstat:
        oldVmstat = cpu_times
        return None, None, None

    c = smbase_pack.CpuLinux()


    all_cpu = cpu_times.user + cpu_times.iowait + cpu_times.idle + cpu_times.system + cpu_times.nice
    last_all_cpu = oldVmstat.user + oldVmstat.iowait + oldVmstat.idle + oldVmstat.system + oldVmstat.nice

    cpu_diff = float(all_cpu - last_all_cpu)
    c.user = jiff * float(cpu_times.user - oldVmstat.user) / cpu_diff
    c.system = jiff * float(cpu_times.system - oldVmstat.system) / cpu_diff
    c.iowait = jiff * float(cpu_times.iowait - oldVmstat.iowait) / cpu_diff
    c.idle = jiff * float(cpu_times.idle - oldVmstat.idle) / cpu_diff
    c.nice = jiff * float(cpu_times.nice - oldVmstat.nice) / cpu_diff
    c.irq = float(0)
    c.softirq = float(0)
    c.steal = float(0)

    cpu_load = psutil.getloadavg()
    c.load1 = cpu_load.load1
    c.load5 = cpu_load.load5
    c.load15 = cpu_load.load15
    oldVmstat = cpu_times

    p = smbase_pack.MemoryLinux()
    vmem = psutil.virtual_memory()

    #
    command = "sysdef | grep bufpages | awk '{print $2}'"
    try:
        bufpages = subprocess.Popen(command, shell=True, stdout=subprocess.PIPE)
        p.cached = int(bufpages.stdout.read().strip('\n')) * vmem.pagesize
    except subprocess.CalledProcessError as e:
        logging_util.debug("cache check error", e)
        p.cached = 0

    p.total = vmem.total
    p.free = vmem.free
    p.used = vmem.used - p.cached
    p.available = vmem.available + p.cached
    p.pused = float(p.used) / float(p.total) * 100.0
    p.pavailable = float(p.available) / float(p.total) * 100.0

    p.buffers = 0
    p.shared = 0

    command = "swapinfo -t | grep total"
    try:
        swapinfo= subprocess.Popen(command, shell=True, stdout=subprocess.PIPE)
        smem = swapinfo.stdout.read().strip('\n').split()
        p.swapTotal = int(smem[1])
        p.swapUsed = int(smem[2])
        p.swapPused = float(smem[2]) / float(smem[1]) * 100.0
    except subprocess.CalledProcessError as e:
        logging_util.debug("cache check error", e)
        p.swapTotal = 0
        p.swapUsed = 0
        p.swapPused = 0

    p.pageFault = 0

    uptime = int(time.time()) - int(psutil.boot_time())

    return c, p, uptime

